﻿Type=Class
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

Sub Class_Globals
	Type Particle(X As Float, Y As Float, Xv As Float, Yv As Float, life As Short, Dead As Boolean, cl As Float, rw As Float)
	Type FireWork(X As Float, Y As Float, Height As Short, Color As Int, Exploded As Boolean, P As List)
	Type PointApi(X As Float, Y As Float)
	Public gv As GameView
	Private FW() As FireWork
	Private RocketSpeed As Short
	Private Timer As Timer
	Private CallBack As Object
	Private ivFireW As BitmapData
	Private Rocket() As BitmapData
	Private nFires As Short
	Private soundCk, stopped As Boolean
	Private fIdx As Short = -1
	Private imgSparks As Bitmap
	Private Karak(96) As String 
	Private bc As ByteConverter
End Sub

Public Sub Initialize(vGV As GameView, CallbackModule As Object, nFr As Short)
	gv = vGV
	nFires = nFr
	CallBack = CallbackModule
	Dim FW(nFires) As FireWork
	Dim Rocket(nFires) As BitmapData
    RocketSpeed = 10
	imgSparks.Initialize(File.DirAssets, "Sparks.png")
    Timer.Initialize("Timer", 16)
	ivFireW.Bitmap.InitializeMutable(100%x, 60%y)
	ivFireW.SrcRect.Initialize(0, 0, ivFireW.Bitmap.Width, ivFireW.Bitmap.Height)
	ivFireW.DestRect.Initialize(0, 0, ivFireW.Bitmap.Width, ivFireW.Bitmap.Height)
	gv.BitmapsData.Add(ivFireW)
	stopped = False
	For i = 0 To nFires - 1
		FW(i).Initialize
		FW(i).Y = -1
		Rocket(i).Bitmap.InitializeMutable(1, 32)
		Rocket(i).SrcRect.Initialize(0, 0, 1, 32)
		Rocket(i).DestRect.Initialize(10, 0, 11, 32)
	Next
	Krk
	createRocket
	StartFireWork
	CallSubDelayed(Me, "starTimer")
End Sub

Private Sub starTimer
	Timer.Enabled = True
End Sub

Private Sub StartFireWork
	If stopped Then
    	For i = 0 To nFires - 1
			If FW(i).Y <> -1 Then Exit
		Next
		If i = nFires Then
			Log("End")
			Timer.Enabled = False
			gv.RemoveView
			
		End If
		Return
	End If
    For i = 0 To nFires - 1
        If FW(i).Y = -1 Then
			If i > 0 Then
    			FW(i).X = Rnd(gv.Width *.1 , gv.Width *.9)
				FW(i).Height = Rnd(10%y, 40%y)
			Else
    			FW(i).X = gv.Width * .5
				FW(i).Height = imgSparks.Height * .5
			End If 
        	FW(i).Y = gv.Height
        	FW(i).Color = Colors.RGB(Rnd(0, 256), Rnd(0, 256), Rnd(0, 256))
        	FW(i).Exploded = False
			FW(i).P.Initialize
			Rocket(i).DestRect.Top = gv.Height
			Rocket(i).DestRect.Bottom = FW(i).Y + 32
			Rocket(i).DestRect.Left = FW(i).X
			Rocket(i).DestRect.Right = FW(i).X + 1
			gv.Invalidate2(Rocket(i).DestRect)
			CallSub2(CallBack, "SoundPlay", 0)
       End If
	Next
End Sub

Private Sub DrawFireWork(idx As Short)
    Dim DeadCount As Short
    Dim RndSpeed As Float
    Dim RndDeg As Float
	If FW(idx).Exploded Then
		Dim cvs As Canvas
		cvs.Initialize2(ivFireW.Bitmap)
		Dim szP As Int  = FW(idx).P.Size
		For i = 0 To szP - 1
			Dim RtSrc, RtDest As Rect
			Dim nFW As Particle = FW(idx).P.Get(i)
			If nFW.Life > 0 Then
				nFW.Life = nFW.Life - 1
				nFW.X = nFW.X + nFW.Xv
				nFW.Y = nFW.Y + nFW.Yv
				nFW.Xv = nFW.Xv / 1.05
				nFW.Yv = nFW.Yv / 1.05 + 0.05
				RtSrc.Initialize(nFW.cl, nFW.rw, nFW.cl + 15, nFW.rw + 15)
				RtDest.Initialize(nFW.X, nFW.Y, nFW.x + 13, nFW.Y + 13)
				cvs.DrawBitmap(imgSparks, RtSrc, RtDest)
			Else If nFW.Life > -40 Then
				nFW.Life = nFW.Life - 1
				nFW.X = nFW.X + nFW.Xv + (0.5 - Rnd(0, 100)/100)
				nFW.Y = nFW.Y + nFW.Yv + 0.1
				nFW.Xv = nFW.Xv / 1.05
				nFW.Yv = nFW.Yv
				RtSrc.Initialize(nFW.cl, nFW.rw, nFW.cl + 15, nFW.rw + 15)
				RtDest.Initialize(nFW.X, nFW.Y, nFW.x + 13, nFW.Y + 13)
				cvs.DrawBitmap(imgSparks, RtSrc, RtDest)
			Else
				nFW.Dead = True
				DeadCount = DeadCount + 1
			End If
		Next
		If soundCk Then
			CallSub2(CallBack, "SoundPlay" , 1)
			soundCk = False
		End If	
		If DeadCount > FW(idx).P.Size -1 Then
			FW(idx).Y = -1
			StartFireWork
		End If
	Else
		FW(idx).Y = FW(idx).Y - RocketSpeed
		If FW(idx).Y < FW(idx).Height Then
			moveRoket(idx, FW(idx).X, gv.Height)
			Dim ExplosionShape As Short
			If idx = 0 Then
				ExplosionShape = Rnd(0, 3)
			Else
				ExplosionShape = Rnd(1, 6)
			End If
			soundCk = True
			Select Case ExplosionShape
				Case 0	'Text
					Dim p As Int =  Rnd(0, 400)
					Dim sTmp As Short = p Mod 20
					If sTmp = 0 Then sTmp = 20
					Dim dist, ang, stp, clft As Float 
					stp = .5
 					Dim strTxt As String = "2017"
					clft = FW(idx).X - ((strTxt.Length-2) * 8 * stp * .5)
					For c = 0 To strTxt.Length - 1
						Dim ch As Int = Asc(strTxt.CharAt(c))
						Dim H() As String = Regex.Split(",", Karak(ch - 32))
						For i =  0 To H.Length - 1
							Dim h1() As Byte  = bc.HexToBytes(H(i))
							Dim bs As String  
							bs = Bit.ToBinaryString(h1(0))
							bs = "00000000" & bs
							bs = bs.SubString(bs.Length - 8)
							Dim ss As String = ""
							For z = 7 To 0 Step - 1
								ss = bs.substring2(z, z + 1) 
								If ss = "1" Then
									Dim nFW As Particle
									nFW.X = FW(idx).X
									nFW.Y = FW(idx).Y
									Dim lft As Float = clft + (c * 8 * stp) - (z * stp) 
									Dim tp As Float = nFW.Y - (16 -i) * stp
									Dim dx As Float = Abs(nFW.X - lft)
									Dim dy As Float = Abs(nFW.Y - tp)
									dist = Sqrt(Power(dx, 2) + Power(dy, 2))
									nFW.Life = 120 
									RndSpeed = dist
									ang	= CalcAngleD(nFW.X, nFW.Y, lft, tp)
									RndDeg = ang / 57.3
									nFW.Xv = RndSpeed * Cos(RndDeg)
									nFW.Yv = RndSpeed * Sin(RndDeg)
									nFW.cl = 15 * (sTmp-1)
									nFW.rw = ((p-sTmp)/20) * 15
									FW(idx).P.Add(nFW)											
								End If
							Next
						Next
					Next
					FW(idx).Exploded = True
				Case 1 'Regular
					Dim tot As Short = Rnd(0, 50) + 50
					Dim p As Int =  Rnd(0, 400)
					Dim sTmp As Short = p Mod 20
					If sTmp = 0 Then sTmp = 20
					For i = 0 To tot-1
						Dim nFW As Particle
						nFW.X = FW(idx).X
						nFW.Y = FW(idx).Y
						nFW.Life = Rnd(0, 20) + 20
						RndSpeed = Rnd(0,  6)
						RndDeg = Rnd(0, 360) / 57.3
						nFW.Xv = RndSpeed * Cos(RndDeg)
						nFW.Yv = RndSpeed * Sin(RndDeg)
						nFW.cl = 15 * (sTmp-1)
						nFW.rw = ((p-sTmp)/20) * 15
						FW(idx).P.Add(nFW)
					Next
					FW(idx).Exploded = True
				Case 2 'Circle
					Dim p As Int =  Rnd(0, 400)
					Dim sTmp As Short = p Mod 20
					If sTmp = 0 Then sTmp = 20
					For i = 0 To 35
						Dim nFW As Particle
						nFW.X = FW(idx).X
						nFW.Y = FW(idx).Y
						nFW.Life = 40
						nFW.Xv = 3 * Cos(((360 / 35) * (i + 1)) / 57.3)
						nFW.Yv = 3 * Sin(((360 / 35) * (i + 1)) / 57.3)
						nFW.cl = 15 * (sTmp-1)
						nFW.rw = ((p-sTmp)/20) * 15
						FW(idx).P.Add(nFW)
					Next 
					FW(idx).Exploded = True
				Case 3 'Spiral
					RndDeg = Rnd(0, 360)
					Dim p As Int =  Rnd(0, 400)
					Dim sTmp As Short = p Mod 20
					If sTmp = 0 Then sTmp = 20
					For i = 0 To 49
						Dim nFW As Particle
						nFW.X = FW(idx).X
						nFW.Y = FW(idx).Y
						nFW.Life = 40
						nFW.Xv = (i * 0.1) * Cos(((360 / 25) * (i + 1) + RndDeg) / 57.3)
						nFW.Yv = (i * 0.1) * Sin(((360 / 25) * (i + 1) + RndDeg) / 57.3)
						nFW.cl = 15 * (sTmp-1)
						nFW.rw = ((p-sTmp)/20) * 15
						FW(idx).P.Add(nFW)
					Next 
					FW(idx).Exploded = True
				Case 4 'Regular Random
					Dim tot As Short = Rnd(0, 50) + 50
					For i = 0 To tot-1
						Dim p As Int =  Rnd(0, 400)
						Dim sTmp As Short = p Mod 20
						If sTmp = 0 Then sTmp = 20
						Dim nFW As Particle
						nFW.X = FW(idx).X
						nFW.Y = FW(idx).Y
						nFW.Life = Rnd(0, 20) + 20
						RndSpeed = Rnd(0,  6)
						RndDeg = Rnd(0, 360) / 57.3
						nFW.Xv = RndSpeed * Cos(RndDeg)
						nFW.Yv = RndSpeed * Sin(RndDeg)
						nFW.cl = 15 * (sTmp-1)
						nFW.rw = ((p-sTmp)/20) * 15
						FW(idx).P.Add(nFW)
					Next 
					FW(idx).Exploded = True
				Case 5
					For i = 0 To 5 
						Dim p As Int =  Rnd(0, 400)
						Dim sTmp As Short = p Mod 20
						If sTmp = 0 Then sTmp = 20
						Dim nFW As Particle
						nFW.X = FW(idx).X
						nFW.Y = FW(idx).Y
						nFW.Life = Rnd(0, 100) + 50
						RndSpeed = Rnd(0,  10)
						RndDeg = Rnd(0, 360) / 60
						nFW.Xv = RndSpeed * Cos(RndDeg)
						nFW.Yv = RndSpeed * Sin(RndDeg)
						nFW.cl = 15 * (sTmp-1)
						nFW.rw = ((p-sTmp)/20) * 15
						FW(idx).P.Add(nFW)
					Next
					FW(idx).Exploded = True					
			End Select
		Else
			moveRoket(idx, FW(idx).X, FW(idx).Y)
		End If
	End If
End Sub

Private Sub moveRoket(ix As Short, l As Float, t As Float)
	Rocket(ix).DestRect.Top = t
	Rocket(ix).DestRect.Bottom = t + 32
	Rocket(ix).DestRect.Left = l 
	Rocket(ix).DestRect.Right = l + 1
End Sub

Private Sub createRocket
	For i = 0 To nFires - 1
		Dim cvs As Canvas
		cvs.Initialize2(Rocket(i).Bitmap)
		cvs.DrawRect(Rocket(i).SrcRect, Colors.Transparent, True, 0)
		For z = 0 To 4
			Dim alp As Int = 255 - z * 51
			cvs.DrawLine(0, z * 8, 0, z * 8 + 8 , Colors.ARGB(alp, 243, 167, 51),1)
		Next		
		cvs.DrawBitmap(Rocket(i).Bitmap, Rocket(i).SrcRect, Rocket(i).DestRect)
		gv.BitmapsData.Add(Rocket(i))
	Next
End Sub

Private Sub Timer_Tick
	For fIdx = 0  To nFires - 1
		DrawFireWork(fIdx) 
	Next
	Dim bmp As Bitmap = CreateBitmapWithAlpha(ivFireW.Bitmap, 245) 
	ivFireW.Bitmap = bmp
	gv.Invalidate
End Sub

Public Sub Stop
	Timer.Enabled = False
	gv.RemoveView
End Sub

Private Sub CreateBitmapWithAlpha(myOriginalBitmap As Bitmap, newAlpha As Int) As Bitmap
  Dim canvas1 As Canvas
  Dim myNewBitmap As Bitmap
  myNewBitmap.initializeMutable(myOriginalBitmap.Width,myOriginalBitmap.Height)
  canvas1.initialize2(myNewBitmap)
  Dim CanvJO As JavaObject = canvas1
  CanvJO = CanvJO.GetField("canvas")  
  Dim J As JavaObject
  J.initializeContext()
  J.Runmethod("alphatize",Array(CanvJO,myOriginalBitmap,newAlpha))
  Return(myNewBitmap)
End Sub

Public Sub CalcAngleD(aX As Float, aY As Float, bX As Float, bY As Float) As Float
    Dim dirX = bX - aX As Float
    Dim dirY = bY - aY As Float
	Return ATan2D(dirY, dirX)
End Sub

Private Sub Krk
	Karak(0) = ("00,00,00,00,00,00,00,00")	'   // U+0020 (space)
    Karak(1) = ("18,3C,3C,18,18,00,18,00")	'   // U+0021 (!)
    Karak(2) = ("36,36,00,00,00,00,00,00")	'   // U+0022 (")
    Karak(3) = ("36,36,7F,36,7F,36,36,00")	'   // U+0023 (#)
    Karak(4) = ("0C,3E,03,1E,30,1F,0C,00")	'   // U+0024 ($)
    Karak(5) = ("00,63,33,18,0C,66,63,00")	'   // U+0025 (%)
    Karak(6) = ("1C,36,1C,6E,3B,33,6E,00")	'   // U+0026 (&)
    Karak(7) = ("06,06,03,00,00,00,00,00")	'   // U+0027 (')
    Karak(8) = ("18,0C,06,06,06,0C,18,00")	'   // U+0028 (()
    Karak(9) = ("06,0C,18,18,18,0C,06,00")	'   // U+0029 ())
    Karak(10) = ("00,66,3C,FF,3C,66,00,00")	'   // U+002A (*)
    Karak(11) = ("00,0C,0C,3F,0C,0C,00,00")	'   // U+002B (+)
    Karak(12) = ("00,00,00,00,00,0C,0C,06")	'   // U+002C (,)
    Karak(13) = ("00,00,00,3F,00,00,00,00")	'   // U+002D (-)
    Karak(14) = ("00,00,00,00,00,0C,0C,00")	'   // U+002E (.)
    Karak(15) = ("60,30,18,0C,06,03,01,00")	'   // U+002F (/)
    Karak(16) = ("3E,63,73,7B,6F,67,3E,00")	'   // U+0030 (0)
    Karak(17) = ("0C,0E,0C,0C,0C,0C,3F,00")	'   // U+0031 (1)
    Karak(18) = ("1E,33,30,1C,06,33,3F,00")	'   // U+0032 (2)
    Karak(19) = ("1E,33,30,1C,30,33,1E,00")	'   // U+0033 (3)
    Karak(20) = ("38,3C,36,33,7F,30,78,00")	'   // U+0034 (4)
    Karak(21) = ("3F,03,1F,30,30,33,1E,00")	'   // U+0035 (5)
    Karak(22) = ("1C,06,03,1F,33,33,1E,00")	'   // U+0036 (6)
    Karak(23) = ("3F,33,30,18,0C,0C,0C,00")	'   // U+0037 (7)
    Karak(24) = ("1E,33,33,1E,33,33,1E,00")	'   // U+0038 (8)
    Karak(25) = ("1E,33,33,3E,30,18,0E,00")	'   // U+0039 (9)
    Karak(26) = ("00,0C,0C,00,00,0C,0C,00")	'   // U+003A (:)
    Karak(27) = ("00,0C,0C,00,00,0C,0C,06")	'   // U+003B (//)
    Karak(28) = ("18,0C,06,03,06,0C,18,00")	'   // U+003C (<)
    Karak(29) = ("00,00,3F,00,00,3F,00,00")	'   // U+003D (=)
    Karak(30) = ("06,0C,18,30,18,0C,06,00")	'   // U+003E (>)
    Karak(31) = ("1E,33,30,18,0C,00,0C,00")	'   // U+003F (?)
    Karak(32) = ("3E,63,7B,7B,7B,03,1E,00")	'   // U+0040 (@)
    Karak(33) = ("0C,1E,33,33,3F,33,33,00")	'   // U+0041 (A)
    Karak(34) = ("3F,66,66,3E,66,66,3F,00")	'   // U+0042 (B)
    Karak(35) = ("3C,66,03,03,03,66,3C,00")	'   // U+0043 (C)
    Karak(36) = ("1F,36,66,66,66,36,1F,00")	'   // U+0044 (D)
    Karak(37) = ("7F,46,16,1E,16,46,7F,00")	'   // U+0045 (E)
    Karak(38) = ("7F,46,16,1E,16,06,0F,00")	'   // U+0046 (F)
    Karak(39) = ("3C,66,03,03,73,66,7C,00")	'   // U+0047 (G)
    Karak(40) = ("33,33,33,3F,33,33,33,00")	'   // U+0048 (H)
    Karak(41) = ("1E,0C,0C,0C,0C,0C,1E,00")	'   // U+0049 (I)
    Karak(42) = ("78,30,30,30,33,33,1E,00")	'   // U+004A (J)
    Karak(43) = ("67,66,36,1E,36,66,67,00")	'   // U+004B (K)
    Karak(44) = ("0F,06,06,06,46,66,7F,00")	'   // U+004C (L)
    Karak(45) = ("63,77,7F,7F,6B,63,63,00")	'   // U+004D (M)
    Karak(46) = ("63,67,6F,7B,73,63,63,00")	'   // U+004E (N)
    Karak(47) = ("1C,36,63,63,63,36,1C,00")	'   // U+004F (O)
    Karak(48) = ("3F,66,66,3E,06,06,0F,00")	'   // U+0050 (P)
    Karak(49) = ("1E,33,33,33,3B,1E,38,00")	'   // U+0051 (Q)
    Karak(50) = ("3F,66,66,3E,36,66,67,00")	'   // U+0052 (R)
    Karak(51) = ("1E,33,07,0E,38,33,1E,00")	'   // U+0053 (S)
    Karak(52) = ("3F,2D,0C,0C,0C,0C,1E,00")	'   // U+0054 (T)
    Karak(53) = ("33,33,33,33,33,33,3F,00")	'   // U+0055 (U)
    Karak(54) = ("33,33,33,33,33,1E,0C,00")	'   // U+0056 (V)
    Karak(55) = ("63,63,63,6B,7F,77,63,00")	'   // U+0057 (W)
    Karak(56) = ("63,63,36,1C,1C,36,63,00")	'   // U+0058 (X)
    Karak(57) = ("33,33,33,1E,0C,0C,1E,00")	'   // U+0059 (Y)
    Karak(58) = ("7F,63,31,18,4C,66,7F,00")	'   // U+005A (Z)
    Karak(59) = ("1E,06,06,06,06,06,1E,00")	'   // U+005B ([)
    Karak(60) = ("03,06,0C,18,30,60,40,00")	'   // U+005C (\)
    Karak(61) = ("1E,18,18,18,18,18,1E,00")	'   // U+005D (])
    Karak(62) = ("08,1C,36,63,00,00,00,00")	'   // U+005E (^)
    Karak(63) = ("00,00,00,00,00,00,00,FF")	'   // U+005F (_)
    Karak(64) = ("0C,0C,18,00,00,00,00,00")	'   // U+0060 (`)
    Karak(65) = ("00,00,1E,30,3E,33,6E,00")	'   // U+0061 (a)
    Karak(66) = ("07,06,06,3E,66,66,3B,00")	'   // U+0062 (b)
    Karak(67) = ("00,00,1E,33,03,33,1E,00")	'   // U+0063 (c)
    Karak(68) = ("38,30,30,3e,33,33,6E,00")	'   // U+0064 (d)
    Karak(69) = ("00,00,1E,33,3f,03,1E,00")	'   // U+0065 (e)
    Karak(70) = ("1C,36,06,0f,06,06,0F,00")	'   // U+0066 (f)
    Karak(71) = ("00,00,6E,33,33,3E,30,1F")	'   // U+0067 (g)
    Karak(72) = ("07,06,36,6E,66,66,67,00")	'   // U+0068 (h)
    Karak(73) = ("0C,00,0E,0C,0C,0C,1E,00")	'   // U+0069 (i)
    Karak(74) = ("30,00,30,30,30,33,33,1E")	'   // U+006A (j)
    Karak(75) = ("07,06,66,36,1E,36,67,00")	'   // U+006B (k)
    Karak(76) = ("0E,0C,0C,0C,0C,0C,1E,00")	'   // U+006C (l)
    Karak(77) = ("00,00,33,7F,7F,6B,63,00")	'   // U+006D (m)
    Karak(78) = ("00,00,1F,33,33,33,33,00")	'   // U+006E (n)
    Karak(79) = ("00,00,1E,33,33,33,1E,00")	'   // U+006F (o)
    Karak(80) = ("00,00,3B,66,66,3E,06,0F")	'   // U+0070 (p)
    Karak(81) = ("00,00,6E,33,33,3E,30,78")	'   // U+0071 (q)
    Karak(82) = ("00,00,3B,6E,66,06,0F,00")	'   // U+0072 (r)
    Karak(83) = ("00,00,3E,03,1E,30,1F,00")	'   // U+0073 (s)
    Karak(84) = ("08,0C,3E,0C,0C,2C,18,00")	'   // U+0074 (t)
    Karak(85) = ("00,00,33,33,33,33,6E,00")	'   // U+0075 (u)
    Karak(86) = ("00,00,33,33,33,1E,0C,00")	'   // U+0076 (v)
    Karak(87) = ("00,00,63,6B,7F,7F,36,00")	'   // U+0077 (w)
    Karak(88) = ("00,00,63,36,1C,36,63,00")	'   // U+0078 (x)
    Karak(89) = ("00,00,33,33,33,3E,30,1F")	'   // U+0079 (y)
    Karak(90) = ("00,00,3F,19,0C,26,3F,00") '   // U+007A (z)
    Karak(91) = ("38,0C,0C,07,0C,0C,38,00") '   // U+007B ({)
    Karak(92) = ("18,18,18,00,18,18,18,00") '   // U+007C (|)
    Karak(93) = ("07,0C,0C,38,0C,0C,07,00") '   // U+007D (})
    Karak(94) = ("6E,3B,00,00,00,00,00,00") '   // U+007E (~)
    Karak(95) = ("00,00,00,00,00,00,00,00") '    // U+007F
End Sub

